var rssStarter = '<?xml version="1.0"?>' +
'<rss version="2.0">'+
	'<channel>'
		+'<title>Surf*Mind*Musings</title>'
		+'<link>http://surfmind.com/musings/</link>'+
		'<description>A playground in the surfmind.</description>'
		+'<copyright>Copyright 2003 Andy Edmonds</copyright>'

		+'<lastBuildDate>Wed, 08 Jan 2003 17:24:23 GMT</lastBuildDate>'+
		'<docs>http://backend.userland.com/rss</docs>'+
		'<generator>Blozom 0.1</generator>'+
		'<managingEditor>andyed@surfmind.com</managingEditor>'
		+'<webMaster>andyed@surfmind.com</webMaster>'+
		'<category domain="http://www.weblogs.com/rssUpdates/changes.xml">rssUpdates</category>'+ 
		'<skipHours>'+
			'<hour>3</hour>'+
			'<hour>4</hour>'+
			'<hour>2</hour>'+
			'<hour>5</hour>'+
			'<hour>1</hour>'+
			'<hour>6</hour>'+

			'<hour>10</hour>'+
			'<hour>17</hour>'+
			'</skipHours>'+
		'<ttl>60</ttl>'+
	'</channel>'+
'</rss>'

var rssXMLdoc = new DOMParser().parseFromString(rssStarter, "text/xml");


// Rewrite to walk map.xml backwards
function writeRSS() {
	var latestMonth = 0;
	var pubCount = 0;
	var tempXML;
	var tempXMLstring;
	var tempContent;
	var tempItem;
	var tempDayDir;
	var latestMonthPath;
	var latestMonth;
	// Begin map.xml rewrite
	var blogPost;
	var postPath;
	var tempFile; 
	var tempCategories;
	// End map.xml rewrite
	var nextToLatestMonth = 0;
	var count = 0;
	var contentObj = new Object;
	dump("\n\n WRITING RSS \n");
	//for(i in weblogRoot) dump(i + "\n");
	var weblogRoot = xfmlRoot.childNodes.item(0).childNodes.item(1);
	dump("looking at weblogroot of " + weblogRoot.nodeName + "\n");
	dumpXML(weblogRoot, 1000);
	// Loop over the content folders in latest month
	for(var j=weblogRoot.childNodes.length-1;j> weblogRoot.childNodes.length - rssMaxFeedItems;j=j-1 ) {
	
		//dump("Looping over " + weblogRoot.childNodes.item(j).nodeName + "\n");
		blogPost = weblogRoot.childNodes.item(j);
		
		postPath = blogPost.getElementsByTagName("path").item(0).childNodes.item(0).nodeValue;
	
		
		if(postPath.indexOf(".txt") > -1) {
			tempFile = new File(postPath);
			
			// BUG: Rely's on directory list ordering
			// of .txt files first.  Should do a structkeyexists
			postFileKey = listLast(postPath);
		// Abstract to blozomRemoveFileExtension
		// End blozomRemoveFileExtension

			postFileKey = postFileKey.replace(".txt","");
			postFileKey = postFileKey.replace(".xml","");
			contentObj[postPath] = new Object;
	
			dump("Reading day " +postPath + "\n");
			tempFile.open("r");
			tempContent = tempFile.read();
			//dump("Content is " + tempContent + "\n\n");
			contentObj[postPath].postContent =tempContent;
			dump("read " + postFileKey + " content \n");

			tempFile.close();
			tempFile = new File(postPath.replace(".txt",".xml"));

			dump("Reading xml " + tempFile.path + "\n")
			tempFile.open("r");
			tempXML = tempFile.read();
			//dump("xml  is " + tempXML + "\n");
			tempFile.close;
			
			dump("----writing "+ postFileKey + " metadata \n");
			// NOt really a string
			tempXMLstring = DOMParser().parseFromString(tempXML, "text/xml");	
			//dump("Xml parsed with " + tempXMLstring.childNodes.item(0).nodeName + " " +  tempXMLstring.childNodes.item(0).childNodes.item(0).childNodes.item(1).nodeName + "\n");
			// Hack date back to GMT
			// TODO Remove this when all ms dates goine
			try {
				var dateNode = tempXMLstring.getElementsByTagName("pubdate").item(0);
				dump("Found date node of " + dateNode.nodeName + " with " + dateNode.childNodes.item(0).nodeValue + "\n");
				var tempDate = new Date();
				tempDate.setTime(dateNode.childNodes.item(0).nodeValue);
				dateNode.childNodes.item(0).nodeValue = tempDate.toGMTString();
			} catch(e) { dump("FAILED ..."); }
			dump("adding " + tempXMLstring + "\n");
			contentObj[postPath ].metaData = tempXMLstring;
		}
	}
	
	blozomPublishCategoryArchives(contentObj);
		
	for(l in contentObj) {
		dump("doing "+ l+ " " + contentObj[l].metaData + " " +  contentObj[l].postContent.length + " in content obj\n");
		dump("Adding post to RSS " + l + "\n");
		
				/*	RSStext2 = new XMLSerializer().serializeToString(contentObj[l].metaData);
			dump("===========\n"+RSStext2 + "\n");*/
			
		tempItem = addContent(contentObj[l].metaData, contentObj[l].postContent);
					/*		RSStext2 = new XMLSerializer().serializeToString(contentObj[l].metaData);
			dump("===========\n"+RSStext2 + "\n"); */
		if(tempItem) appendItem(tempItem);
						/*	RSStext2 = new XMLSerializer().serializeToString(contentObj[l].metaData);
			dump("===========\n"+RSStext2 + "\n"); */
	}
	

	dump("Converting RSS to string \n");
	var RSStext = new XMLSerializer().serializeToString(rssXMLdoc);
	//dump("Rss text is " + RSStext + "\n");
	blozomSaveMainRSS(RSStext);

}

function blozomPublishCategoryArchives(contentObj) {
	dump("Publishing category RSS \n");
	var blozomPublishCategories = blozomRssCategories.split(",");
	var tempItem;
	var categoryNodes;
	var rssCategoryXMLdoc;
	var rssTex2;
	var numStories = 0;
	for(var m=0; m < blozomPublishCategories.length;m++) {
		rssCategoryXMLdoc = new DOMParser().parseFromString(rssStarter, "text/xml");
		for(l in contentObj) {
			dump("Serializing  " + contentObj[l].postContent.length +"\n");
			dump("Meta data is " + contentObj[l].metaData + "\n");
			RSStext2 = new XMLSerializer().serializeToString(contentObj[l].metaData);
			dump(RSStext2 + "\n");
			//dump("Looking for category at " + l + "\n");
			dump("metadata is " + contentObj[l].metaData.nodeName +  " of len " + contentObj[l].metaData.childNodes.item(0).nodeName + "\n");
			categoryNodes = contentObj[l].metaData.childNodes.item(0).getElementsByTagName("category");
			//dump("found " + categoryNodes.length + " cateogires \n");
			for(var n=0; n<categoryNodes.length;n++) {

				dump("Comparing " + categoryNodes.item(n).childNodes.item(0).nodeValue + " to " + blozomPublishCategories[m] + "\n");
			if(categoryNodes.item(n).childNodes.item(0).nodeValue == blozomPublishCategories[m] ) {
				tempItem = addContent(contentObj[l].metaData, contentObj[l].postContent);
				if(tempItem) {
					rssCategoryXMLdoc = appendItemTo(tempItem, rssCategoryXMLdoc);
					numStories++;
				}
				}
			}
		}
		if(numStories > 0) {
		RSStext = new XMLSerializer().serializeToString(rssCategoryXMLdoc);
		categoryFilePath = blozomPublishPath + "\\" + blozomCategoriesFolder + "\\" + blozomPublishCategories[m].toLowerCase() + "\\rss.xml";
		dump("prepping to write " + categoryFilePath + "\n");
		blozomInsurePath(categoryFilePath);
		categoryFile = new File(categoryFilePath);
		categoryFile.open("w");
		categoryFile.write(RSStext);
		categoryFile.close
		dump("\n\n\n==== TO PUBLISH in CATGORY " + blozomPublishCategories[m]  + " ==== \n");
		}
	}
}



function blozomSaveMainRSS(blob) {
	var rssFile = new File(blozomPublishPath + "\\rss.xml");
	if(!rssFile.exists()) {
		rssFile.create();
	}
	rssFile.open('w',744);
	rssFile.write(blob);
	rssFile.close();
}


function addContent(itemData, itemContent) {	
	try {
	dump("\nSSSSuccess Adding content " + itemContent.length + "\n\n");
	//dump("Adding content " + itemContent + "\n\n");
	dump("Item data is " + itemData.nodeName + "\n");
	//root.channel...
	// Patch up xml doc
	dump("Item data is "+ itemData.nodeName + "\n");
	var myTextNode = document.createTextNode(itemContent);
	//dump("Created text node \n");
	// description is 2nd element
	
	var descriptionNode = itemData.childNodes.item(0).childNodes.item(0).childNodes.item(1);
	dump("description NOde is " + descriptionNode.nodeName + "\n");
	descriptionNode.appendChild(myTextNode);
	return itemData;
	/*
	// Attach it to RSS 
	var attachPoint = itemData.childNodes.item(0).childNodes.item(0);
	
	attachPoint.
	dump("Adding content to " + item.nodeName + "\n");
	//var tempNode = document.createElement("description");
	
	//item.appendChild(tempNode); */ 
	} catch(e) {
		dump("FFFFailure in category RSS " + e + "\n");
		return false;
	}
}

function appendItem( item) {
	dump("appending" + item.nodeName + "\n");
	var RSStext = new XMLSerializer().serializeToString(item);
//dump("Rss text is " + RSStext + "\n");
	dump("channel node is " + rssXMLdoc.childNodes.item(0).childNodes.item(0).nodeName + "\n");
	// don't forget to trim off the xml node in argument
	rssXMLdoc.childNodes.item(0).childNodes.item(0).appendChild(item.childNodes.item(0).childNodes.item(0));
}

function appendItemTo( item, destination) {
	dump("appending" + item.nodeName + "\n");
	var RSStext = new XMLSerializer().serializeToString(item);
//dump("Rss text is " + RSStext + "\n");
	dump("channel node is " + destination.childNodes.item(0).childNodes.item(0).nodeName + "\n");
	// don't forget to trim off the xml node in argument
	destination.childNodes.item(0).childNodes.item(0).appendChild(item.childNodes.item(0).childNodes.item(0));
	return destination;
}