var htmlDocument;
var dragBoard = false;
var maxZ =0;
var windowX;
var windowY;
var notesInited = false;
/*
Spec: Moving stores a percentage offset xy
	Resizing adjusts position accordingly
	Big resizes adjust font size

*/

function initNotes() {
	dump("INITING \n\n");
	//window.resizeTo(800,600);
	buildNotes(opener.blozomDataPath + blozomNotesPath);
	loadNotePositions(opener.blozomDataPath + blozomNotesPath);
	window.title = "BlozomNoteView: " + blozomNotesPath;
	//window.addEventListener("resize", handleResize, false);


}

function loadNotePositions(notesDir) {
	var windowX = window.innerWidth;
	var windowY = window.innerHeight;
	var tempNode, tempId, tempX, tempY;
	var metaFilePath = notesDir + "\\notes.xml";
	dump("Loading metadata for " + metaFilePath + "\n");
	var metaFile = new File(metaFilePath);
	if(metaFile.exists()) {
		metaFile.open("r");
		var metaContent = metaFile.read();
		var metaContentDoc = new DOMParser().parseFromString(metaContent, "text/xml");
		var rootNode = metaContentDoc.childNodes.item(0);
		for(var i=0; i<rootNode.childNodes.length;i++) {
			tempNode = rootNode.childNodes.item(i);
			dump("Node " + tempNode.nodeName + "\n");
			tempId = tempNode.getAttribute("id");
			tempX= tempNode.getAttribute("top");
			tempY = tempNode.getAttribute("left");
			tempZ = tempNode.getAttribute("z-index");
			htmlDocument.getElementById(tempId).style.top = tempY * windowY;
			htmlDocument.getElementById(tempId).style.left = tempX * windowX;
			htmlDocument.getElementById(tempId).setAttribute("percentageY", tempY);
			htmlDocument.getElementById(tempId).setAttribute("percentageX", tempX);
			htmlDocument.getElementById(tempId).style.zIndex = tempZ;
			htmlDocument.getElementById(tempId).style.left = tempX * windowX;
			
			dump("Node " + htmlDocument.getElementById(tempId) + " moved to " + tempX + " " + tempY + "\n");
			notesInited = true;
			
		}
		dump("Root is " + rootNode.nodeName + "\n");
	} else {
		dump("No meta notes file found \n");

	}
	
}



function rand(maxNumber) {
    var generatornum=Math.random();
	return randomnum=Math.round(generatornum*maxNumber);
}


function buildNotes(dirPath, layoutObj) {
	dump("Building NOtes \n");
	// TODO: remove hack, isolate cause of mutliple build invocation

	var noteDir = new Dir(dirPath);
	var myNotes = noteDir.readDir();
//var top, left, plotX, plotY, incrementX, incrementY;
	if(!layoutObj) {
		layoutObj = new Object		
		windowX = window.innerWidth -100;
		windowY = window.innerHeight -100;
	// Setup autoTiling
	// assuming 300 width
	layoutObj.plotX = 20; //windowX - 320;
	layoutObj.plotY = 20;
	dump("&&& diving " + windowX + " " + myNotes.length + "\n");
	layoutObj.incrementX = windowX / myNotes.length;
	layoutObj.incrementY = windowY / myNotes.length;
	// End Setup Tiling			
	}
	dump("Noting " + dirPath + "\n");

	htmlDocument = document.getElementById("blozom-notes-frame").contentDocument;
	dump("looking at window " +htmlDocument.innerHeight +"\n");
	/* windowX = parseInt(htmlDocument.innerHeight);
	windowY = parseInt(htmlDocument.innerWidth); */

	var protoNode = htmlDocument.getElementById("blozom-note-template");
	var stackNode = htmlDocument.getElementById("blozom-note-stack");
	dump("building notes with " + protoNode.nodeName + " from " + dirPath + "\n");
	var tempNode = false;
	var boxTitle;
	var myNotes;
	var nodeContent = '';

	

	dump("Autotile incrfement is " + layoutObj.incrementX + " " + layoutObj.incrementY + "\n");
	var tempTitle, textBoxNode, titleTextNode;
	for(var i=0; i < myNotes.length; i++) {
		dump("Noting " + myNotes[i].path  + "\n");
		if(myNotes[i].isFile()) {
			maxZ++;
			top = layoutObj.plotY;
			left= layoutObj.plotX;
			
			dump("drawing at " + top + " " + left +  " with " + tempNode.nodeName + "\n");
			myNotes[i].open("r");
			nodeContent = myNotes[i].read();
			myNotes[i].close();
			tempNode = protoNode.cloneNode(true);
			// Don't stack if we've loaded a position file
			dump("Pondering note inited flag of " + notesInited + "\n");
			tempNode.style.top = top + "px";
			tempNode.style.left = left + "px";
			dump("plotting to " + top + " " + left + "\n");
		
			if(tempNode.style.top < windowY && tempNode.style.left < windowX) {
				tempNode.setAttribute("percentX", left/windowX);
				tempNode.setAttribute("percentY", top/windowY);
			} else {
				tempNode.setAttribute("percentX", left/640);
				tempNode.setAttribute("percentY", top/480);
			}
			
			tempNode.style.display = '';
			tempNode.style.zIndex = maxZ;
			textBoxNode = tempNode.childNodes.item(1);

			//dump("len is " + textBoxNode.textLength + "\n");
			textBoxNode.value = nodeContent;
			
			//dump("len is " + textBoxNode.textLength + "\n");
			dump("Setting content at " + textBoxNode.nodeName  + " " + textBoxNode.childNodes.length + "\n");
			//textBoxNode.value = nodeContent;
			
			//dump("Note content is " + nodeContent.length + "\n");

			dump(opener.blozomDataPath + " vs " + myNotes[i].path + "\n");

			titleTextNode = tempNode.childNodes.item(0);			
			//dump("Setting title at " + titleTextNode.nodeName + "\n");
			tempTitle= myNotes[i].path + '';
			tempTitle = tempTitle.replace(opener.blozomDataPath, '');
			tempTitle = tempTitle.replace("\\blozom\\","");
			tempTitle = tempTitle.replace(".txt", "");
			//dump("regined title is " + tempTitle + "\n");
			tempNode.setAttribute("id", replaceAll(tempTitle,"\\","-"));
			dump("id is " + replaceAll(tempTitle,"\\","-") + "\n");
			tempTitle = '<input type="button" style="float:right;font-size:8px" value="save" disabled="false"/>' + tempTitle;
			titleTextNode.innerHTML =  tempTitle + "<br/>";
			//tempNode.setAttribute("id", tempTitle);
			//titleTextNode.value = "val " + tempTitle;
			htmlDocument.body.appendChild(tempNode);
			//setupNodeEvents(htmlDocument, replaceAll(tempTitle,"\\","")); 
			layoutObj.plotX += layoutObj.incrementX;
			layoutObj.plotY += layoutObj.incrementY;
		} else {
			dump("Recursing \n");
			buildNotes(myNotes[i].path, layoutObj);
		}
		
	}
	return layoutObj;
	
	
}

function setupNodeEvents(htmlDocument, nodeId) {
	var node = htmlDocument.getElementById(nodeId);
	
	dump("SSSetting up event node " + node + "\n");
	if(node) {
	node.childNodes.item(0).addEventListener("mousedown", monitorMove, false);
	
	} else {
		dump("No events added\n");
	}
	
}





function walkUpForNote(target) {
	dump("walking " + target.nodeName + " ");
	if(target.nodeName == "DIV" && target.hasAttribute("noteNode")) {
		dump("\n returning " + target.nodeName + "\n");
		return target; 
	} else {
		return walkUpForNote(target.parentNode);
	}
}

function handleResize() {
	dump("Handling resize \n");
	var tempNode;
	windowX = window.innerWidth;
	windowY = window.innerHeight;
	for(var i=0;i<htmlDocument.body.childNodes.length;i++) {
		tempNode = htmlDocument.body.childNodes.item(i);
		if(tempNode.nodeName == "DIV") {
			dump("looking at div at " + tempNode.style.top + " " + tempNode.getAttribute("percentY") + " " + tempNode.style.left + " " + tempNode.getAttribute("percentX") + "\n");
			tempNode.style.top = tempNode.getAttribute("percentY") * windowY;
			tempNode.style.left = tempNode.getAttribute("percentX") * windowX;
			
		}
	}
}

function blozomNoteNew() {
	var userPath = prompt("Enter a name for your note");
	if(userPath.indexOf(".txt") == -1) userPath += ".txt";
	var fullPath = opener.blozomDataPath + blozomNotesPath + userPath;
	dump("Creating new note at " + fullPath + "\n");
}